package com.massa.util.extensions.nativeproperty.compiler;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.net.URI;
import java.net.URISyntaxException;

import javax.tools.SimpleJavaFileObject;

/**
 * Represents compiled code.
 */
public class CompiledCode extends SimpleJavaFileObject {
	private final ByteArrayOutputStream baos = new ByteArrayOutputStream();

	public CompiledCode(final String className) throws URISyntaxException {
		super(new URI(className), Kind.CLASS);
	}

	@Override
	public OutputStream openOutputStream() {
		return this.baos;
	}

	public byte[] getByteCode() {
		return this.baos.toByteArray();
	}
}
