package com.massa.util.extensions.nativeproperty.compiler;

import javax.tools.FileObject;
import javax.tools.ForwardingJavaFileManager;
import javax.tools.JavaFileManager;
import javax.tools.JavaFileObject;

/**
 * Allows to handle in-memory source code.
 */
public class ExtendedStandardJavaFileManager extends ForwardingJavaFileManager<JavaFileManager> {

	private final CompiledCode compiledCode;
	private final DynamicClassLoader cl;

	/**
	 * Creates a new instance of ForwardingJavaFileManager.
	 *
	 * @param fileManager delegate to this file manager
	 * @param cl
	 */
	protected ExtendedStandardJavaFileManager(final JavaFileManager fileManager, final CompiledCode compiledCode, final DynamicClassLoader cl) {
		super(fileManager);
		this.compiledCode = compiledCode;
		this.cl = cl;
		this.cl.setCode(compiledCode);
	}

	@Override
	public JavaFileObject getJavaFileForOutput(
			final JavaFileManager.Location location, final String className, final JavaFileObject.Kind kind, final FileObject sibling) {
		return this.compiledCode;
	}

	@Override
	public ClassLoader getClassLoader(final JavaFileManager.Location location) {
		return this.cl;
	}
}
